VERSION 5.00
Begin VB.Form MainForm 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "RSUPL_LOOP"
   ClientHeight    =   5730
   ClientLeft      =   1380
   ClientTop       =   1665
   ClientWidth     =   9465
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5730
   ScaleWidth      =   9465
   Begin VB.CheckBox AudioMonitor 
      Caption         =   "Audio Monitor"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   540
      TabIndex        =   7
      Top             =   1920
      Width           =   1515
   End
   Begin VB.CommandButton Start 
      Caption         =   "START"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   1320
      TabIndex        =   5
      Top             =   3060
      Width           =   2835
   End
   Begin VB.ListBox Result 
      BackColor       =   &H80000004&
      Height          =   2985
      Left            =   5940
      TabIndex        =   4
      Top             =   960
      Width           =   2835
   End
   Begin VB.HScrollBar Volume 
      Height          =   315
      Left            =   2640
      Max             =   100
      MousePointer    =   10  'Aufwrtspfeil
      TabIndex        =   3
      Top             =   1980
      Value           =   30
      Width           =   2295
   End
   Begin VB.CheckBox Reset 
      Caption         =   "RESET"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   195
      Left            =   3120
      TabIndex        =   2
      Top             =   1140
      Width           =   1035
   End
   Begin VB.TextBox IEEEAdr 
      Height          =   315
      Left            =   480
      TabIndex        =   1
      Text            =   "GPIB::20"
      Top             =   960
      Width           =   1875
   End
   Begin VB.Label Label 
      Alignment       =   2  'Zentriert
      Caption         =   "Volume %"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Index           =   1
      Left            =   2760
      TabIndex        =   8
      Top             =   1680
      Width           =   2115
   End
   Begin VB.Label VSet 
      Alignment       =   2  'Zentriert
      Caption         =   "--"
      Height          =   195
      Left            =   5100
      TabIndex        =   6
      Top             =   2100
      Width           =   495
   End
   Begin VB.Label Label 
      Alignment       =   2  'Zentriert
      Caption         =   "IEEE adr"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Index           =   0
      Left            =   480
      TabIndex        =   0
      Top             =   600
      Width           =   1875
   End
End
Attribute VB_Name = "MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Example: Sweep measurement controlled by external loop
'
'note
' please install the VXIPnP driver for UPL first
' it is necessary to use National Instruments Visa 2.01 or higher
'
' Revision 1.1, 08/2006
' Removed rsupl_32.dll reference in project settings
' Added rsupl.bas and Visa32.bas
' Please find rsupl.bas and Visa32.bas in VXIPnP folder ~\WinNT\include
' Fixed rsupl.bas file - please install VXIPnP diver for UPL Revision 2.23.1, 08/2006 first.
' By: Werner Klotzsche, Rohde & Schwarz

' Original Release:
' By: Werner Klotzsche, Rohde & Schwarz
' Revision 1.0 06/2002

Option Explicit

Dim I As Integer
Dim instrSession As Long
Dim errorMessage As String * 256
Dim value As Double
Dim frequency As Double
Dim strBuf2 As String * 10
Dim strBuf3 As String * 10
Dim strBuf4 As String * 10
Dim strBuf5 As String * 10
Dim strBuf6 As String * 10
Dim strBuf7 As String * 10
Dim strBuf8 As String * 10


Private Sub Start_Click()

Dim ECode As Long

Dim I As Integer
  
    
    'initialize and reset to a known state
    ECode = rsupl_init(IEEEAdr.Text, 1, Reset.value, instrSession)
    ErrHan ECode, "rsupl_init"
        
    'config trigger
    ECode = rsupl_confInstrTrig(instrSession, VI_FALSE)
    ErrHan ECode, "rsupl_confInstrTrig"
    
    'config universal analog generator
    ECode = rsupl_confGenAnStp(instrSession, 3, VI_FALSE, 0, 10#, 1000#, 1#, 0, 0)
    ErrHan ECode, "rsupl_confGenAnStp"
      
    'config sine output
    ECode = rsupl_confGenFuncSin(instrSession, VI_FALSE, 1000, 0, VI_FALSE, 0, 0, 1, 0, VI_FALSE, "*.veq", VI_FALSE, 0, 15, 0, VI_FALSE)
    ErrHan ECode, "rsupl_confGenFuncSin"
    
    'config 22kHz analog analyzer
    ECode = rsupl_confAnalyzerAnalStp(instrSession, 600#, 0, VI_TRUE, VI_FALSE, 1, 1, VI_FALSE, VI_FALSE, 1, 0, 8, 0, VI_FALSE)
    ErrHan ECode, "rsupl_confAnalyzerAnalStp"
    
    'config RMS measurement
    ECode = rsupl_confAnalyzerFuncRMSSN(instrSession, VI_FALSE, 2, 0.3, 0, 0, 0#, VI_FALSE, 0, 1#, 0, 0, 0, 10#)
    ErrHan ECode, "rsupl_confAnalyzerFuncRMSSN"
    
    'select filter
    ECode = rsupl_confAnalyzerFilterSel(instrSession, 10, 0, 0)
    ErrHan ECode, "rsupl_confAnalyzerFilterSel"
    
    'enhance measurement speed
    'switch off display & cursors
    ECode = rsupl_confInstrDisplay(instrSession, VI_TRUE, VI_FALSE)
    ErrHan ECode, "rsupl_confInstrDisplay"
         
        
    'switch off sense 2 & 3
    ECode = rsupl_confInstrSense(instrSession, VI_TRUE, VI_FALSE, VI_FALSE)
    ErrHan ECode, "rsupl_confInstrSense"
    
    'audio monitor available?
    ECode = rsupl_confInstrOpt(instrSession, strBuf2, strBuf3, strBuf4, strBuf5, strBuf6, strBuf7, strBuf8)
    ErrHan ECode, "rsupl_confInstrOpt"
        
     If AudioMonitor.value Then
        ECode = rsupl_confInstrAudioMonitor(instrSession, AudioMonitor.value, 1, VI_FALSE, 0, Volume.value)
        ErrHan ECode, "rsupl_confInstrAudioMonitor"
    End If
    

    Result.Clear
    For I = 0 To 100
        frequency = Exp(Log(10) * ((I / 50) + 2))
        ECode = rsupl_setFreqLevel(instrSession, VI_TRUE, frequency, 0, VI_FALSE, 1, 0)
        ErrHan ECode, "rsupl_setFreqLevel"
        ECode = rsupl_sendTrig(instrSession)
        ErrHan ECode, "rsupl_sendTrig"
        ECode = rsupl_measSingleCh(instrSession, VI_FALSE, 0, value)
        ErrHan ECode, "rsupl_measSingleCh"
        
        Result.AddItem Exp(Log(10) * ((I / 50) + 2))
        DoEvents
        If value < 1E+30 Then
           Result.AddItem value
         Else: Result.AddItem "-NA-"
        End If
        DoEvents
    Next I

End Sub

Private Sub Volume_Change()

VSet.Caption = Str$(Volume.value)

End Sub

Private Sub Volume_Scroll()

Volume_Change

End Sub


Private Sub ErrHan(ByVal error As Long, Command As String)

If error <> 0 Then
    Call MsgBox("Error " + Str$(error) + " for command " + Command, vbOKOnly, "ERROR")
    End
End If

End Sub

